#include "uart.h"
#define UART_RX_BUF 10


static uint8_t rxbuffer[UART_RX_BUF];
static uint8_t rxIn;
static uint8_t rxOut;
static uint8_t txIn;
static uint8_t txOut;


ISR(USART_RXC_vect)
{
	rxbuffer[rxIn] = UDR;
	rxIn++;
	if (rxIn >= UART_RX_BUF)
		rxIn = 0;
}


ISR(USART_TXC_vect)
{

}


void init_uart()
{
	/*UART initialisieren*/
	UBRRH = UBR_VAL >> 8;
	UBRRL = UBR_VAL & 0xFF;
	UCSRB |= (1 << TXEN);  									// UART TX einschalten
	UCSRC = (1<<URSEL) | (1<<UCSZ1) | (1<<UCSZ0);  			// Asynchron 8N1 --> fr ATmega16
	//UCSRC = (1<<UCSZ1) | (1<<UCSZ0);  					// Asynchron 8N1 --> fr Migration ATmega16 to ATmega644

	rxIn = rxOut = 0;
	txIn = txOut = 0;
}


int uart_putc(unsigned char c)
{
    while (!(UCSRA & (1 << UDRE)))
    {
    }

    UDR = c;
    return 0;
}


void uart_puts (char *s)
{
    while (*s)
    {
    	uart_putc(*s);
        s++;
    }
}
